<template>
  <div class="my-aircraft">
    <h4 class="page-title mb-6" v-text="$t('pilotPanel.myAircraft.title')" />

    <vx-card class="mb-6 pt-4 pb-2">
      <!-- Photos -->
      <h4
        class="mb-6 text-center sm:text-left"
        style="color: gray;"
      >{{ `${$t('pilotPanel.myAircraft.photos')}` }}</h4>

      <d-note v-if="noImages" :text="$t('pilotPanel.myAircraft.noPhotoWarning')" color="warning"></d-note>

      <d-image-uploader
        :max-images="6"
        :images-ids="addForm.photos"
        :load-images="addForm.photos.length > 0"
        :push-images-to-server="pushImages"
        @uploadedToServer="updateAircraft"
        @changedQuantity="changedImagesQuantity"
      />
      <!-- General -->
      <h4
        class="mb-6 text-center sm:text-left"
        style="color: gray;"
      >{{ $t('pilotPanel.myAircraft.generalInfo') }}</h4>

      <div class="vx-row w-full mb-0 sm:mb-6">
        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-input
            v-model="addForm.name"
            validate="required|max:32"
            :label="$t('pilotPanel.myAircraft.aircraftName')"
          />
        </div>
        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-select
            v-model="addForm.type"
            :list="aircraftTypes"
            :text-params="['name']"
            value-param="id"
            :label="$t('pilotPanel.myAircraft.type')"
            required
          />
        </div>

        <div class="vx-col w-full sm:w-1/3 mb-6 sm:mb-0">
          <d-input
            v-model="addForm.airport"
            validate="required|max:32"
            :label="$t('pilotPanel.myAircraft.airportName')"
          />
        </div>
      </div>

      <div class="vx-row w-full mb-0 sm:mb-6">
        <div class="vx-col w-full sm:w-1/4 mb-6 sm:mb-0">
          <d-input
            v-model.number="addForm.passangers"
            validate="required|max_value: 99|min_value:0"
            :label="$t('pilotPanel.myAircraft.passangers')"
            type="number"
          />
        </div>

        <div class="vx-col w-full sm:w-1/4 mb-6 sm:mb-0">
          <d-input
            v-model.number="addForm.maxTime"
            validate="required|max_value:300|min_value:0"
            :label="$t('pilotPanel.myAircraft.maxTime')"
            type="number"
          />
        </div>
      </div>
      <!-- lugguage -->
      <h4
        class="mb-6 text-center sm:text-left"
        style="color: gray; margin-top: 40px;"
      >{{ $t('pilotPanel.myAircraft.lugguage') }}</h4>

      <div class="vx-row w-full mb-0 sm:mb-6">
        <div class="vx-col w-full sm:w-1/4 mb-6 sm:mb-0">
          <d-checkbox
            v-model="addForm.lugguage.handLuggageOnly"
            :title="$t('pilotPanel.myAircraft.handLuggageOnly')"
          />
        </div>

        <div class="vx-col w-full sm:w-1/4 mb-6 sm:mb-0">
          <d-input
            v-model.number="addForm.lugguage.bagsUnderTenKg"
            validate="max_value:20|min_value:0"
            :label="$t('pilotPanel.myAircraft.bagsUnderTenKg')"
            type="number"
            :disabled="addForm.lugguage.handLuggageOnly"
          />
        </div>

        <div class="vx-col w-full sm:w-1/4 mb-6 sm:mb-0">
          <d-input
            v-model.number="addForm.lugguage.bagsAboveTenKg"
            validate="max_value:20|min_value:0"
            :label="$t('pilotPanel.myAircraft.bagsAboveTenKg')"
            type="number"
            :disabled="addForm.lugguage.handLuggageOnly"
          />
        </div>
      </div>
      <div class="vx-row w-full mb-0 sm:mb-6">
        <div class="vx-col w-full sm:w-1/4 mb-6 sm:mb-0">
          <d-input
            v-model.number="addForm.lugguage.maxWidth"
            validate="max_value:400|min_value:0"
            :label="$t('pilotPanel.myAircraft.maxWidth')"
            type="number"
            :disabled="addForm.lugguage.handLuggageOnly"
          />
        </div>
        <div class="vx-col w-full sm:w-1/4 mb-6 sm:mb-0">
          <d-input
            v-model.number="addForm.lugguage.maxHeight"
            validate="max_value:400|min_value:0"
            :label="$t('pilotPanel.myAircraft.maxHeight')"
            type="number"
            :disabled="addForm.lugguage.handLuggageOnly"
          />
        </div>
        <div class="vx-col w-full sm:w-1/4 mb-6 sm:mb-0">
          <d-input
            v-model.number="addForm.lugguage.maxDepth"
            validate="max_value:400|min_value:0"
            :label="$t('pilotPanel.myAircraft.maxDepth')"
            type="number"
            :disabled="addForm.lugguage.handLuggageOnly"
          />
        </div>
      </div>
      <div class="vx-row w-full mb-0 sm:mb-6">
        <div class="vx-col w-full">
          <vs-button
            type="filled"
            style="margin-top: 22px;"
            class="action-btn"
            :disabled="hasErrors || !allRequiredFilled"
            :color="hasErrors || !allRequiredFilled
              ? '#bbbbbb'
              : 'primary'"
            @click="save"
          >{{ $t('generalTitles.save') }}</vs-button>
        </div>
      </div>
    </vx-card>
  </div>
</template>

<script lang="ts">
import api from "@/api/aircraft.api.ts";
import { Component, Vue } from "vue-property-decorator";
import {
  DInput,
  DDate,
  DSelect,
  DCheckbox,
  DNote,
  DImageUploader
} from "@/components/d-elements";
import { AIRCRAFT_TYPES } from "@/helpers/constants";

@Component({
  components: {
    DDate,
    DInput,
    DSelect,
    DCheckbox,
    DNote,
    DImageUploader
  }
})
export default class MyAircraft extends Vue {
  private addForm = {
    photos: [],
    name: "",
    type: "",
    airport: "",
    passangers: 1,
    maxTime: null,
    lugguage: {
      bagsUnderTenKg: null,
      bagsAboveTenKg: null,
      handLuggageOnly: false,
      maxWidth: null,
      maxHeight: null,
      maxDepth: null
    }
  };

  private aircraftTypes = AIRCRAFT_TYPES;
  private noImages = false;
  private pushImages = false;

  get hasErrors() {
    // @ts-ignore
    return this.errors.items.length > 0;
  }

  get allRequiredFilled() {
    return (
      this.addForm.name &&
      this.addForm.type &&
      this.addForm.airport &&
      this.addForm.passangers &&
      this.addForm.maxTime
    );
  }

  created() {
    this.getAircraft();
  }

  private async getAircraft() {
    await api.getAircraft().then(response => {
      this.addForm = response.data;
    });
  }

  private async updateAircraft(imagesIds) {
    this.pushImages = false;
    this.addForm.photos = imagesIds;
    await api.updateAircraft(this.addForm).then(response => {
      if (response.status === 200) {
        this.$store.dispatch("appState/showAlert", {
          mode: "success",
          title: this.$t("notifications.successfully"),
          text: this.$t("notifications.saved")
        });
      }
    });
  }

  private changedImagesQuantity(val) {
    if (val === 0) {
      this.noImages = true;
    } else {
      this.noImages = false;
    }
  }

  private save() {
    this.pushImages = true;
  }
}
</script>

<style lang="scss">
.my-aircraft {
}
</style>